routes/web.php
<?php

/* Route For Main View */
Route::get('/', function () {
    return redirect('/login');
});

/* Route For Auth */
Auth::routes();

/* Route For Main Menu */
Route::group(
    [
        'prefix' => 'admin',
        'middleware' => ['auth', 'role:admin|marketing|operator|ppic|gudang'],
    ],
    function () {
        //Route Home
        Route::get('/home/{tahun}', 'admin\HomeController@index');
        
        //Route User
        Route::resource('master/users', 'Admin\UsersController');

        //Route Raw Material
        Route::resource('master/raws', 'Admin\RawsController');

        //Route Color Type
        Route::resource('master/colors', 'Admin\ColorsController');

        //Route Product Type
        Route::resource('master/products', 'Admin\ProductsController');

        //Route Machine Group
        Route::resource('master/groups', 'Admin\GroupsController');

        //Route Marketing (Delivery Order)
        Route::resource('marketing/orders', 'Admin\MarketingsController');
        Route::get('marketing/orders/get_id/{table}', [
            'as' => 'orders.getId',
            'uses' => 'Admin\MarketingsController@getId',
        ]);
        Route::get('marketing/orders/product_detail/{product_id}', 'Admin\MarketingsController@productDetail');

        //Route Change Password
        Route::get('change_password', [
            'as' => 'change_password',
            'uses' => 'Admin\UsersController@changePassword',
        ]);
        Route::post('store_password', [
            'as' => 'store_password',
            'uses' => 'Admin\UsersController@storeNewPassword',
        ]);

        //Route Incoming
        Route::get('inventory/incomings/create', [
            'as' => 'incomings.create',
            'uses' => 'Admin\InvController@incCreate',
        ]);
        Route::post('inventory/incomings/inc_detail', [
            'as' => 'incomings.inc_detail',
            'uses' => 'Admin\InvController@incDetail',
        ]);
        Route::post('inventory/incomings/inc_finish', [
            'as' => 'incomings.inc_finish',
            'uses' => 'Admin\InvController@incFinish',
        ]);
        Route::get('inventory/incomings/raw_detail/{id}', [
            'uses' => 'Admin\InvController@incRawDetail',
        ]);
        Route::post('inventory/incomings/store', [
            'as' => 'incomings.store',
            'uses' => 'Admin\InvController@incStore',
        ]);
        Route::get('inventory/incomings/get_id/{table}', [
            'as' => 'incomings.getId',
            'uses' => 'Admin\InvController@getId',
        ]);

        //Route Stock Raw Material
        Route::get('inventory/stocks/raw_material', [
            'as' => 'stocks.raw_material',
            'uses' => 'Admin\InvController@rawStock',
        ]);
        Route::get('inventory/stocks/{id}/edit', [
            'as' => 'stocks.edit',
            'uses' => 'Admin\InvController@editStock',
        ]);
        Route::put('inventory/stocks/update/{id}', [
            'as' => 'stocks.update',
            'uses' => 'Admin\InvController@updateStock',
        ]);
        Route::delete('inventory/stocks/{id}', [
            'as' => 'stocks.destroy',
            'uses' => 'Admin\InvController@destroyStock',
        ]);
        Route::delete('inventory/stocks/remove/{id}', [
            'as' => 'stocks.remove',
            'uses' => 'Admin\InvController@removeStock',
        ]);
        
        //Route PPIC SPK Base Material to Coloring Order
        Route::resource('ppic/colorings', 'Admin\PpicsController');
        Route::get('ppic/colorings/get_id/{table}', [
            'as' => 'colorings.getId',
            'uses' => 'Admin\PpicsController@getId',
        ]);
        Route::get('ppic/colorings/do_detail/{table}', 'Admin\PpicsController@doDetail');

        Route::get('ppic/table/{type}', [
            'as' => 'ppic.table',
            'uses' => 'Admin\PpicsController@table',
        ]);

        //Route PPIC SPK to Cutting finish good Roll
        Route::get('ppic/cuttings', [
            'as' => 'cuttings.index',
            'uses' => 'Admin\PpicsController@cuttingIndex',
        ]);
        Route::get('ppic/cuttings/create', [
            'as' => 'cuttings.create',
            'uses' => 'Admin\PpicsController@cuttingCreate',
        ]);
        Route::get('ppic/colorings/get_laminating_id/{table}', [
            'as' => 'colorings.getLaminatingId',
            'uses' => 'Admin\PpicsController@getLaminatingId',
        ]);
        Route::post('ppic/cuttings/store', [
            'as' => 'cuttings.store',
            'uses' => 'Admin\PpicsController@cuttingStore',
        ]);
        Route::get('ppic/cuttings/{cutting}/edit', [
            'as' => 'cuttings.edit',
            'uses' => 'Admin\PpicsController@cuttingEdit',
        ]);
        Route::put('ppic/cuttings/{cutting}', [
            'as' => 'cuttings.update',
            'uses' => 'Admin\PpicsController@cuttingUpdate',
        ]);
        Route::delete('ppic/cuttings/{cutting}', [
            'as' => 'cuttings.destroy',
            'uses' => 'Admin\PpicsController@cuttingDestroy',
        ]);

        //Route Production
        Route::get('production/base', [
            'as' => 'productions.base',
            'uses' => 'Admin\ProductionsController@baseColored',
        ]);
        Route::get('production/base/table_status', 'Admin\ProductionsController@tableStatus');
        Route::get('production/base/do_spk_list/{marketing_id}', 'Admin\ProductionsController@doSpk');
        Route::get('production/base/do_raw_list/{inc_detail_id}', 'Admin\ProductionsController@doRaw');
        Route::post('production/base/base_proccess', 'Admin\ProductionsController@baseProccess');
        Route::post('production/base/raw_colored_store', 'Admin\ProductionsController@rawColoredStore');
        
        Route::get('production/laminating/table_non', 'Admin\ProductionsController@tableStatusLaminatingNon');
        Route::get('production/laminating/table_colored', 'Admin\ProductionsController@tableStatusLaminatingColored');
        Route::post('production/laminating/laminating_proccess', 'Admin\ProductionsController@laminatingProccess');
        Route::get('production/laminating', 'Admin\ProductionsController@laminating');
        Route::get('production/laminating/do_spk_list/{marketing_id}', 'Admin\ProductionsController@doSpkLaminating');
        Route::get('production/laminating/do_raw_list/{color_type}/{ppic_id}', 'Admin\ProductionsController@doRawLaminating');

        Route::post('production/laminating/laminating_colored_store', 'Admin\ProductionsController@laminatingColoredStore');
        Route::post('production/laminating/laminating_colored_store_finish', 'Admin\ProductionsController@laminatingColoredStoreFinish');
        Route::post('production/laminating/laminating_noncolored_store', 'Admin\ProductionsController@laminatingNonColoredStore');
        Route::post('production/laminating/laminating_noncolored_store_finish', 'Admin\ProductionsController@laminatingNonColoredStoreFinish');
        
        Route::get('result/{tahun}/{table}', [
            'as' => 'result.index',
            'uses' => 'Admin\ResultController@index'
        ]);

        Route::get('result_fgs/{tahun}', [
            'as' => 'result.fgs',
            'uses' => 'Admin\ResultController@fgs'
        ]);

        Route::get('result_laminating/{tahun}', [
            'as' => 'result.laminating',
            'uses' => 'Admin\ResultController@laminating'
        ]);

        //SPK FGS
        Route::get('ppic/fgs', [
            'as' => 'fgs.index',
            'uses' => 'Admin\PpicsController@fgsIndex',
        ]);
        Route::get('ppic/fgs/create', [
            'as' => 'fgs.create',
            'uses' => 'Admin\PpicsController@fgsCreate',
        ]);
        Route::post('ppic/fgs/store', [
            'as' => 'fgs.store',
            'uses' => 'Admin\PpicsController@fgsStore',
        ]);
        Route::get('ppic/fgs/{fgs}/edit', [
            'as' => 'fgs.edit',
            'uses' => 'Admin\PpicsController@fgsEdit',
        ]);
        Route::put('ppic/fgs/{fgs}', [
            'as' => 'fgs.update',
            'uses' => 'Admin\PpicsController@fgsUpdate',
        ]);
        Route::delete('ppic/fgs/{fgs}', [
            'as' => 'fgs.destroy',
            'uses' => 'Admin\PpicsController@fgsDestroy',
        ]);

        Route::get('production/fgs', 'Admin\ProductionsController@fgs');

        Route::get('production/fgs/do_spk_list/{marketing_id}', 'Admin\ProductionsController@doSpkFgs');
        Route::post('production/fgs/fgs_proccess', 'Admin\ProductionsController@fgsProccess');
        Route::post('production/fgs/fgs_store', 'Admin\ProductionsController@fgsStore');
        Route::post('production/fgs/fgs_store_finish', 'Admin\ProductionsController@fgsStoreFinish');
    }
);

Route::get('auth/verify/{token}', 'Auth\RegisterController@verify');
Route::get('auth/send-verification', 'Auth\RegisterController@sendVerification');

app/Raw.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Raw extends Model
{
    protected $guarded = ['id'];
    protected $fillable = ['raw_type', 'spec', 'thick', 'width', 'user_id'];

    public function incdetail()
    {
        return $this->hasMany('App\IncDetail');
    }
    
    public function user()
    {
        return $this->belongsTo('App\User');
    }
    
}

app/Http/Controllers/Admin/RawsController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Str;
use Datatables;
use Validator;
use App\Raw;
use Auth;

class RawsController extends Controller
{
   
    public function index(Request $request)
    {
        if ($request->ajax()) {
            $raws = Raw::select(['id', 'raw_type', 'spec', 'thick', 'width', 'user_id'])->get();
            return Datatables::of($raws)
                ->addColumn('user', function ($raw) {
                    return ucfirst($raw->user->name);
                })
                ->addColumn('action', function ($raw) {
                    return view('admin.datatables._action', [
                        'id' => $raw->id,
                        'destroy_url' => route('raws.destroy', $raw->id),
                        'edit_url' => route('raws.edit', $raw->id),
                        'confirm_message' => 'Yakin ingin menghapus tipe raw material ' . $raw->raw_type . ' ?',
                    ]);
                })
                ->rawColumns(['user', 'action'])
                ->filter(function ($instance) use ($request) {
                    if (!empty($request->get('raw_type'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['raw_type'], $request->get('raw_type')) ? true : false;
                        });
                    }
                    if (!empty($request->get('spec'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['spec'], $request->get('spec')) ? true : false;
                        });
                    }
                    if (!empty($request->get('thick'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['thick'], $request->get('thick')) ? true : false;
                        });
                    }
                    if (!empty($request->get('width'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['width'], $request->get('width')) ? true : false;
                        });
                    }
                    if (!empty($request->get('user'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['user'], $request->get('user')) ? true : false;
                        });
                    }

                })
                ->make(true);
        }

        $data['title'] = 'Daftar Tipe Raw Material';
        return view('admin.raw.index', $data);
    }

    public function create()
    {
        $data['title'] = 'Tambah Tipe Raw Material';
        return view('admin.raw.create', $data);
    }

 
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'raw_type' => 'required|unique:raws',
            'spec' => 'required',
            'thick' => 'required',
            'width' => 'required'
        ]);

        if ($validator->passes()) {
            $data = $request->all();
            $data['user_id'] = Auth::user()->id;

            $raw = Raw::create($data);
            return response()->json(['success' => 'Tipe Raw Material berhasil ditambahkan']);
        } else {
            return response()->json(['error' => $validator->getMessageBag()->toArray()]);
        }
    }

    public function show($id)
    {
        //
    }

    public function edit($id)
    {   
        $title = 'Edit Tipe Raw Material';
        $raw = Raw::find($id);
        return view('admin.raw.edit')
            ->with(compact('raw', 'title'));
    }

    public function update(Request $request, $id)
    {
        $validator = Validator::make($request->all(), [
            'raw_type' => 'required|unique:raws,raw_type,' . $id,
            'spec' => 'required',
            'thick' => 'required',
            'width' => 'required'
        ]);

        if ($validator->passes()) {
            $raw = Raw::find($id);
            $raw->update($request->all());
            return response()->json(['success' => 'Berhasil mengubah data Tipe Raw Material']);
        } else {
            return response()->json(['error' => $validator->getMessageBag()->toArray()]);
        }
    }

    public function destroy($id)
    {
        $raw = Raw::where('id', $id)->delete();
        return response()->json(['id' => $id]);

    }
}

resources/views/admin/raw/_form.blade.php
<div class="form-group group-raw_type">
    {!! Form::label('raw_type', 'Tipe Raw Material', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        {!! Form::text('raw_type', null, ['class' => 'form-control', 'style' => 'color:black;cursor:pointer;', 'readonly']) !!}
    </div>
</div>

<div class="form-group group-spec">
    {!! Form::label('spec', 'Spesifikasi', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        {!! Form::select('spec', ['' => '- Pilih Spesifikasi -','Soft' => 'Soft', 'Hard' => 'Hard'], (empty($raw)) ? null : $raw->spec, 
        ['class' => 'form-control', 'onchange' => 'generate_code()']) !!}
    </div>
</div>

<div class="form-group group-thick">
    {!! Form::label('thick', 'Tebal', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        {!! Form::number('thick', null, ['class' => 'form-control', 'step' => '0.01', 'onkeyup' => 'generate_code()']) !!}
    </div>
</div>

<div class="form-group group-width">
    {!! Form::label('width', 'Lebar', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        {!! Form::number('width', null, ['class' => 'form-control', 'onkeyup' => 'generate_code()']) !!}
    </div>
</div>

@section('scripts')
<script>
    function generate_code() {
        var segment = "{{ $title }}";
        if (segment == 'Tambah Tipe Raw Material') {
            var spec = $("#spec").val();
            var thick = $("#thick").val();
            var width = $("#width").val();
            
            $("#raw_type").val("RM/"+thick+"/"+width+"/"+spec);
        }
    }
</script>
@endsection

resources/views/admin/raw/create.blade.php
@extends('admin.layouts.app')

@section('content')
<ul class="breadcrumb">
    <li>Master Data</li>
    <li>Tipe Raw Material</li>
    <li class="active">Tambah Data</li>
</ul>


<div class="page-content-wrap">
    <div class="row row-bg">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Form Tipe Raw Material</h3>
                </div>
                {!! Form::open(['url' => route('raws.store'), 'class' => 'form-horizontal form-save', 'method' =>'post', 'data-rule' => 'store']) !!}
                <div class="panel-body">
                    <a class="btn btn-default waves-effect" href="{{ route('raws.index') }}">
                        <i class="fa fa-arrow-left"> Kembali</i>
                    </a>
                    <hr>
                    <div class="row">
                        <div class="col-md-6">
                            @include('admin.raw._form')
                        </div>
                    </div>
                </div>
                <div class="panel-footer">
                    {!! Form::submit('Simpan', ['class'=>'btn btn-primary pull-right', 'id' => 'btn-save']) !!}
                </div>
                {!! Form::close() !!}
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/admin/raw/edit.blade.php
@extends('admin.layouts.app')

@section('content')
<ul class="breadcrumb">
    <li>Master Data</li>
    <li>Tipe Raw Material</li>
    <li class="active">Edit</li>
</ul>

<div class="page-content-wrap">
    <div class="row row-bg">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Daftar Tipe Raw Material</h3>
                </div>
                {!! Form::model($raw, ['url' => route('raws.update', $raw->id), 'class' => 'form-horizontal form-save',
                 'method' =>'put', 'data-redirect' => route('raws.index')]) !!}
                <div class="panel-body">
                    <a class="btn btn-default waves-effect" href="{{ route('raws.index') }}">
                        <i class="fa fa-arrow-left"> Kembali</i>
                    </a>
                    <hr>
                    <div class="row">
                        <div class="col-md-6">
                            @include('admin.raw._form')
                        </div>
                    </div>
                </div>
                <div class="panel-footer">
                    {!! Form::submit('Simpan', ['class'=>'btn btn-primary pull-right', 'id' => 'btn-save']) !!}
                </div>
                {!! Form::close() !!}
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/admin/raw/index.blade.php
@extends('admin.layouts.app')

@section('content')
<ul class="breadcrumb">
    <li>Master Data</li>
    <li class="active">Tipe Raw Material</li>
</ul>

<div class="page-content-wrap">
    <div class="row row-bg">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Daftar Tipe Raw Material</h3>
                </div>
                <div class="panel-body">
                    <div class="row">
                        <a class="btn btn-default waves-effect" href="{{ route('raws.create') }}">Tambah Tipe Raw Material</a>
                        <hr>
                        <div class="col-md-12">
                            <table id="raws" class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th width="10%">ID</th>
                                        <th>Type Raw Material</th>
                                        <th>Spesifikasi</th>
                                        <th>Tebal</th>
                                        <th>Lebar</th>
                                        <th>Dibuat Oleh</th>
                                        <th width="10%">Action</th>
                                    </tr>
                                </thead>
                                <tfoot>
                                    <tr>
                                        <td></td>
                                        <td>
                                            {!! Form::text('raw_type', null, ['class' => 'form-control', 'placeholder' =>
                                            'Tipe Material', 'id' => 'raw_type']) !!}
                                        </td>
                                        <td>
                                            {!! Form::text('spec', null, ['class' => 'form-control', 'placeholder' =>
                                            'Spesifikasi', 'id' => 'spec']) !!}
                                        </td>
                                        <td>
                                            {!! Form::number('thick', null, ['class' => 'form-control', 'placeholder' =>
                                            'Tebal', 'id' => 'thick']) !!}
                                        </td>
                                        <td>
                                            {!! Form::number('width', null, ['class' => 'form-control', 'placeholder' =>
                                            'Lebar', 'id' => 'width']) !!}
                                        </td>
                                        <td>
                                            {!! Form::number('user', null, ['class' => 'form-control', 'placeholder' =>
                                            'Pengguna', 'id' => 'user']) !!}
                                        </td>
                                        <td></td>
                                    </tr>
                                </tfoot>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('scripts')
<script raw_type="text/javascript">
    $(function () {
        var table = $('#raws').DataTable({
            processing: false,
            serverSide: true,
            ajax: {
                url: "{{ route('raws.index') }}",
                data: function (d) {
                    d.raw_type = $('#raw_type').val(),
                    d.spec = $('#spec').val(),
                    d.thick = $('#thick').val(),
                    d.width = $('#width').val(),
                    d.user = $('#user').val()
                }
            },
            columns: [{
                    data: 'id',
                    name: 'id'
                },
                {
                    data: 'raw_type',
                    name: 'raw_type'
                },
                {
                    data: 'spec',
                    name: 'spec'
                },
                {
                    data: 'thick',
                    name: 'thick'
                },
                {
                    data: 'width',
                    name: 'width'
                },
                {
                    data: 'user',
                    name: 'user'
                },
                {
                    data: 'action',
                    name: 'action',
                    orderable: false,
                    searchable: false
                }
            ]
        });

        $('#raw_type').on('change', function () {
            table.draw();
        });

        $('#spec').on('change', function () {
            table.draw();
        });

        $('#thick').on('change', function () {
            table.draw();
        });

        $('#width').on('change', function () {
            table.draw();
        });

        $('#user').on('change', function () {
            table.draw();
        });


    });
</script>
@endsection

@section('style')
<style>
    #raws_filter {
        display: none;
    }
</style>
@endsection